/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file    gpio.h
  * @brief   This file contains all the function prototypes for
  *          the gpio.c file
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2022 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __GPIO_H__
#define __GPIO_H__

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "main.h"

/* USER CODE BEGIN Includes */

/* USER CODE END Includes */

/* USER CODE BEGIN Private defines */

/* USER CODE END Private defines */

void MX_GPIO_Init(void);

/* USER CODE BEGIN Prototypes */

enum
{
	SysLed,
	RedLed,
	GreenLed,
	BlueLed,
	LedMax,
};

enum
{
	Relay1,
	Relay2,
	RelayMax,
};

#define OFF        0
#define ON         1

typedef struct gpio_s
{
	const char          *name;
	GPIO_TypeDef        *group;
	uint16_t             pin;
} gpio_t;

extern gpio_t     relays[RelayMax];
extern gpio_t     leds[LedMax] ;

/*  函数说明???? 控制LED????/灭的功能函数
* 参数说明???? which指定要控制哪个灯，取值为枚举里的 RedLed、GreenLed或BlueLed
*            status要控制灯亮还是灭，取值为宏定???? ON ???? OFF
*   返回值： ????
*/
extern void turn_led(int which, int status);

/*  函数说明???? 控制LED闪烁的功能函????
* 参数说明???? which指定要控制哪个灯，取值为枚举里的 RedLed、GreenLed或BlueLed
*            interval指定闪烁的间隔时间，其单位为毫秒
*   返回值： ????
*/
extern void blink_led(int which, uint32_t interval);


extern void sysled_hearbeat(void);


extern void turn_relay(int which, int status);

/* USER CODE END Prototypes */

#ifdef __cplusplus
}
#endif
#endif /*__ GPIO_H__ */

