/**********************************************************************
*   Copyright: (C)2021 LingYun IoT System Studio <www.weike-iot.com>
*      Author: GuoWenxue<guowenxue@gmail.com> QQ: 281143292
* Description: NB-IoT module source code
*
*
*   ChangeLog:
*        Version    Date       Author            Description
*        V1.0.0  2022.05.1  GuoWenxue      Release initial version
***********************************************************************/

#ifndef SRC_NBIOT_H_
#define SRC_NBIOT_H_

#include "bc28.h"

#define IOT_PLATFORM_SERVER      "221.229.214.202,5683"  /* China Telecom */

extern int g_nbiot_status;
extern int g_nbiot_signal;

extern int g_nbiot_status;

extern int nbiot_module_init(void);

extern int nbiot_check_module(void);

extern int nbiot_module_reset(void);

extern int nbiot_set_manual_connect(void);

extern int nbiot_set_auto_connect(void);

extern int init_iot_platform(void);



enum
{
	NBIOT_STATUS_NOTREADY,
	NBIOT_STATUS_CFUN_OK,
	NBIOT_STATUS_SIM_OK,
	NBIOT_STATUS_REG_OK,
	NBIOT_STATUS_NET_OK,
	NBIOT_STATUS_IOT_OK,
	NBIOT_STATUS_READY = NBIOT_STATUS_IOT_OK,
};
extern int nbiot_check_status(void);

extern int nbiot_update_status(void);

#endif /* SRC_NBIOT_H_ */
